#import "NetServiceBrowserDelegate.h"
#import "MateriaController.h"

@implementation NetServiceBrowserDelegate

- (id)init
{
	self = [super init];
	services = [[NSMutableArray alloc] init];
	searching = NO;
	return self;
}

- (void)dealloc
{
	[services release];
	[super dealloc];
}

- (void)setController:(MateriaController *)c
{
	controller = c;
}

- (void)netServiceBrowserWillSearch:(NSNetServiceBrowser *)browser
{
	searching = YES;
	[self updateUI];
}

- (void)netServiceBrowserDidStopSearch:(NSNetServiceBrowser *)browser
{
	searching = NO;
	[self updateUI];
}

- (void)netServiceBrowser:(NSNetServiceBrowser *)browser didNotSearch:(NSDictionary *)errorDict
{
	searching = NO;
	[self handleError:[errorDict objectForKey:NSNetServicesErrorCode]];
}

- (void)netServiceBrowser:(NSNetServiceBrowser *)browser didFindService:(NSNetService *)aNetService moreComing:(BOOL)moreComing
{
	[playersArrayController addObject:aNetService];
	NSLog(@"Found a player: %@", [aNetService name]);
	NSLog(@"Services: %d", [services count]);
	NSLog(@"Players: %d", [[playersArrayController content] count]);
	if(!moreComing)
	{
		[self updateUI];
	}
}

- (void)netServiceBrowser:(NSNetServiceBrowser *)browser didRemoveService:(NSNetService *)aNetService moreComing:(BOOL)moreComing
{
	[playersArrayController removeObject:aNetService];
	NSLog(@"Lost a player: %@", [aNetService name]);
	NSLog(@"Services: %d", [services count]);
	NSLog(@"Players: %d", [[playersArrayController content] count]);
	if(!moreComing)
	{
		[self updateUI];
	}
}

- (void)handleError:(NSNumber *)error
{
	NSLog(@"An error occurred. Error code = %d", [error intValue]);
	[controller displayMessage:(@"An error occurred. Error code = %d", [error intValue])];
}

- (void)updateUI
{
	if(searching)
	{
		[controller spinProgressIndicator:self];
	}
	else
	{
		[controller stopProgressIndicator:self];
	}
}

@end
